Imports System
Imports System.Text
Imports System.ComponentModel
Imports System.Data
imports System.collections
Imports Microsoft.VisualBasic

Imports SchemaExplorer
Imports Codesmith.Engine
<CLSCompliant(False)> _
Public Class SqlCodeTemplate
Inherits CodeTemplate
   'This variable is used to control the indent of the 
   'formatted code that is output in conjunction with
   'the Level method
   Const INDENT_LEVEL_SPACES As Integer = 3
   Public Enum AccessibilityEnum
      [Public]
      [Protected]
      [Friend]
      [Private]
   End Enum
   <CLSCompliant(False)> _
    Public Function GetVBAccessModifier(ByVal Accessibility As AccessibilityEnum) As String
      Select Case (Accessibility)
         Case AccessibilityEnum.Public
            Return "Public"
         Case AccessibilityEnum.Protected
            Return "Protected"
         Case AccessibilityEnum.Friend
            Return "Friend"
         Case AccessibilityEnum.Private
            Return "Private"
         Case Else
            Return "Public"
      End Select
   End Function
   <CLSCompliant(False)> _
    Public Function GetClassName(ByVal Table As TableSchema) As String

      Static oDic As System.Collections.Specialized.StringDictionary = New System.Collections.Specialized.StringDictionary

      Dim sTableName As String
      Dim sClassName As String

      sClassName = oDic.Item(Table.Name)
      If Not sClassName Is Nothing Then
         Return sClassName
      End If
      sTableName = Table.Name
      Try
         sClassName = ""
         sClassName = GetDescriptionProperty("Single", Table.PrimaryKey.MemberColumns(0))
      Catch
      End Try
      If sClassName <> "" Then
         oDic.Add(Table.Name, sClassName)
         Return sClassName
      End If
      If (Table.Name.EndsWith("n")) Then ' use this in german
         sClassName = Table.Name.Substring(0, Table.Name.Length - 1)
      Else
         sClassName = Table.Name
      End If
      sClassName = InputBox("Singular name for Table " & Table.Name, , sClassName)
      oDic.Add(Table.Name, sClassName)
      Return sClassName
   End Function
   <CLSCompliant(False)> _
    Public Function GetVBVariableType(ByVal Column As ColumnSchema) As String

      Select Case (Column.DataType)
         Case DbType.AnsiString
            Return "String"
         Case DbType.AnsiStringFixedLength
            Return "String"
         Case DbType.Binary
            Return "Byte()"
         Case DbType.Boolean
            Return "Boolean"
         Case DbType.Byte
            Return "Byte"
         Case DbType.Currency
            Return "Decimal"
         Case DbType.Date
            Return "Date"
         Case DbType.DateTime
            Return "Date"
         Case DbType.Decimal
            Return "Decimal"
         Case DbType.Double
            Return "Double"
         Case DbType.Guid
            Return "Guid"
         Case DbType.Int16
            Return "Short"
         Case DbType.Int32
            Return "Integer"
         Case DbType.Int64
            Return "Long"
         Case DbType.Object
            Return "object"
         Case DbType.[SByte]
            Return "Sbyte!!!!"
         Case DbType.Single
            Return "Float"
         Case DbType.String
            Return "String"
         Case DbType.StringFixedLength
            Return "String"
         Case DbType.Time
            Return "TimeSpan"
         Case DbType.UInt16
            Return "Ushort!!!"
         Case DbType.UInt32
            Return "Uint!!!"
         Case DbType.UInt64
            Return "Ulong!!!!"
         Case DbType.VarNumeric
            Return "Decimal"
         Case Else
            Return "__UNKNOWN__" + Column.NativeType
      End Select
   End Function
   <CLSCompliant(False)> _
   Public Function GetVBXPOStringSizeAttribute(ByVal Column As ColumnSchema) As String
      Dim s As String
      s = GetVBVariableType(Column)
      If s = "String" Then
         If Column.Size >= 1073741823 Then
            Return "Size(SizeAttribute.Unlimited)"
         Else
            Return "Size(" & Column.Size.ToString & ")"
         End If
      End If
      Return ""
   End Function
   <CLSCompliant(False)> _
    Public Function GetVBVariablePrefix(ByVal Infix As String, ByVal Column As ColumnSchema) As String
      If (Column.Name.EndsWith("TypeCode")) Then Return Column.Name
      Select Case (Column.DataType)
         Case DbType.AnsiString
            Return "s" & Infix
         Case DbType.AnsiStringFixedLength
            Return "s" & Infix
         Case DbType.Binary
            Return "byte" & Infix
         Case DbType.Boolean
            Return "b" & Infix
         Case DbType.Byte
            Return "byte" & Infix
         Case DbType.Currency
            Return "y" & Infix
         Case DbType.Date
            Return "a" & Infix
         Case DbType.DateTime
            Return "a" & Infix
         Case DbType.Decimal
            Return "y" & Infix
         Case DbType.Double
            Return "d" & Infix
         Case DbType.Guid
            Return "guid" & Infix
         Case DbType.Int16
            Return "is" & Infix
         Case DbType.Int32
            Return "i" & Infix
         Case DbType.Int64
            Return "l" & Infix
         Case DbType.Object
            Return "o" & Infix
         Case DbType.[SByte]
            Return "Sbyte!!!!" & Infix
         Case DbType.Single
            Return "f" & Infix
         Case DbType.String
            Return "s" & Infix
         Case DbType.StringFixedLength
            Return "s" & Infix
         Case DbType.Time
            Return "TimeSpan" & Infix
         Case DbType.UInt16
            Return "Ushort!!!" & Infix
         Case DbType.UInt32
            Return "Uint!!!" & Infix
         Case DbType.UInt64
            Return "Ulong!!!!" & Infix
         Case DbType.VarNumeric
            Return "y" & Infix
         Case Else
            Return "__UNKNOWN__" + Column.NativeType
      End Select
   End Function
   <CLSCompliant(False)> _
   Public Function GetVBVariable(ByVal Accessibility As AccessibilityEnum, ByVal Infix As String, ByVal Column As ColumnSchema) As String
      Dim sb As New StringBuilder
      sb.Append(GetVBVariablePrefix(Infix, Column))
      sb.Append(Column.Name)
      Return sb.ToString
   End Function
   <CLSCompliant(False)> _
   Public Function GetVBVariableDeclaration(ByVal Accessibility As AccessibilityEnum, ByVal Infix As String, ByVal Column As ColumnSchema) As String
      Dim sb As New StringBuilder
      sb.Append(GetVBAccessModifier(Accessibility))
      sb.Append(" ")
      sb.Append(GetVBVariable(Accessibility, Infix, Column))
      sb.Append(" as ")
      sb.Append(GetVBVariableType(Column))
      Return sb.ToString
   End Function
   <CLSCompliant(False)> _
   Public Function GetVbForeignKeyVariableDeclaration(ByVal Accessibility As AccessibilityEnum, ByVal Infix As String, ByVal KeyTable As TableKeySchema) As String
      Dim sb As New StringBuilder
      sb.Append(GetVBAccessModifier(Accessibility))
      sb.Append(" ")
      sb.Append("o" & Infix)
      sb.Append(GetClassName(KeyTable.PrimaryKey.Table))
      sb.Append(" as ")
      sb.Append(GetClassName(KeyTable.PrimaryKey.Table))
      Return sb.ToString
   End Function
   <CLSCompliant(False)> _
   Public Function GetVBPropertyGetSet(ByVal Accessibility As AccessibilityEnum, ByVal Infix As String, ByVal Column As ColumnSchema) As String
      Dim sb As New StringBuilder
		dim sV as String =GetVBVariable(Accessibility, Infix, Column)

      sb.AppendFormat(" {0} Property {1}() as {2}" & vbcrlf,GetVBAccessModifier(Accessibility),Column.Name,GetVBVariableType(Column))
      sb.Append("	Get" &vbcrlf )
      sb.AppendFormat("		return {0}" & vbcrlf , sV, Column)
      sb.Append("	End Get" & vbCrLf)

      sb.Append("	Set(ByVal Value as " & GetVBVariableType(Column) & ")" & vbCrLf)
		sb.append("		if " & sV & " = Value then " & vbcrlf)
		sb.append("			Return" & vbcrlf)
		sb.append("		End If" & vbcrlf)
		sb.append("		Dim old" & sV & " as " & GetVBVariableType(Column) & vbcrlf)
		sb.append("		old" & sV & " = " & sV & vbcrlf)
		sb.Append("		" & sV & " = Value" & vbCrLf)
		sb.Append("		OnChanged(""" & Column.Name & """,old" & sV & ",Value )" & vbcrlf )
      sb.Append("	End Set" & vbCrLf)
      sb.Append("End Property" & vbCrLf)
      Return sb.ToString
   End Function
   <CLSCompliant(False)> _
   Public Function GetVbForeignKeyObject(ByVal Accessibility As AccessibilityEnum, ByVal Infix As String, ByVal KeyTable As TableKeySchema ,IncludeDescriptionAttribute as Boolean,IncludeTooltipAttribute as Boolean) As String
    	Dim sb As New StringBuilder
		Dim s as string
		dim sV as String = "o" & Infix & GetClassName(KeyTable.PrimaryKey.Table)
    	
		Dim sAssocName as string = GetClassName(KeyTable.PrimaryKey.Table) & "_" & KeyTable.ForeignKeyTable.Name
		Dim sFKName as string = KeyTable.ForeignKeyMemberColumns(0).Name
		If KeyTable.ForeignKeyMemberColumns.Count > 1 then
			Response.writeline("' ToDo: Caution MultiColumnforeignkey " )
	   End If		
      sb.Append("< _" & vbcrlf)
		s=GetVbAttributes(KeyTable.ForeignKeyMemberColumns(0),IncludeDescriptionAttribute,IncludeTooltipAttribute)
		If s <> "" then s=s & ", _" & vbcrlf
		sb.append(s)
      sb.Append(vbtab & "Persistent(" & """" & sFKName & """" & "), _" & vbCrLf)
      sb.Append(vbtab & "Association(" & """")
      	sb.Append(sAssocName)
      	sb.Append("""")
      	sb.Append(") _" & vbCrLf)
		sb.append("> _" & vbcrlf)
      sb.Append(GetVBAccessModifier(Accessibility))
      sb.Append(" Property ")
      sb.Append(GetClassName(KeyTable.PrimaryKey.Table) & " ()")
      sb.Append(" as ")
      sb.Append(GetClassName(KeyTable.PrimaryKey.Table))
      sb.Append(vbCrLf)
      sb.Append(vbTab & "Get" & vbCrLf)
      sb.Append(vbTab & vbTab & "return ")
      sb.Append("o" & Infix)
      sb.Append(GetClassName(KeyTable.PrimaryKey.Table) & vbCrLf)
      sb.Append(vbTab & "End Get" & vbCrLf)

     ' sb.Append(vbTab & "Set(ByVal Value as " & GetClassName(KeyTable.PrimaryKey.Table) & ")" & vbCrLf)
	'	sb.Append(vbTab & vbTab & "o" & Infix & GetClassName(KeyTable.PrimaryKey.Table) & "  = Value" & vbCrLf)
    '  sb.Append(vbTab & "End Set" & vbCrLf)

      sb.Append("	Set(ByVal Value as " & GetClassName(KeyTable.PrimaryKey.Table) & ")" & vbCrLf)
		sb.append("		if Object.Equals(" &  sV & ",Value) then " & vbcrlf)
		sb.append("			Return" & vbcrlf)
		sb.append("		End If" & vbcrlf)
		sb.append("		Dim old" & sv & " as " & GetClassName(KeyTable.PrimaryKey.Table) & vbcrlf)
		sb.append("		old" & sV & " = " & sV & vbcrlf)
		sb.Append("		" & sV & " = Value" & vbCrLf)
		sb.Append("		OnChanged(""" & GetClassName(KeyTable.PrimaryKey.Table) & """," & sV & ",Value )" & vbcrlf )
      sb.Append("	End Set" & vbCrLf)		
		
		
		sb.Append("End Property" & vbCrLf)
      Return sb.ToString
   End Function
   <CLSCompliant(False)> _
   Public Function GetVbOneSideKeyObject(ByVal Accessibility As AccessibilityEnum, ByVal Infix As String, ByVal Table As TableSchema, ByVal KeyTable As TableKeySchema,IncludeDescriptionAttribute as boolean, IncludeTooltipAttribute as boolean ) As String
      Dim sb As New StringBuilder
	  Dim sAssocName as string = GetClassName(Table) & "_" & KeyTable.ForeignKeyTable.Name
      If Table.Name = KeyTable.ForeignKeyTable.Name Then
         Return ""
      End If
	  	sb.Append("< _" & vbcrlf)
		if IncludeDescriptionAttribute then
	  		sb.Append(vbtab & "SX.Attributes.Description(""" & KeyTable.ForeignKeyTable.Name & """), _ " & vbcrlf)
		end If
		If IncludeTooltipAttribute then
	  		sb.Append(vbtab & "SX.Attributes.Tooltip(""" & KeyTable.ForeignKeyTable.Name & """), _ " & vbcrlf)
		end If
	  	sb.Append(vbtab & "Displayname(""" & KeyTable.ForeignKeyTable.Name & """), _ " & vbcrlf)
      	sb.Append(vbtab & "Aggregated(), _" & vbcrlf)
	  	sb.Append(vbtab & "Association(" & """")
      		sb.Append(sAssocName)
      		sb.Append("""" & " , Gettype(" & GetClassName(KeyTable.ForeignKeyTable) & ")) _" & vbcrlf)
      	sb.Append("> _ " & vbcrlf )
      sb.Append(GetVBAccessModifier(Accessibility))
      sb.Append(" Readonly Property ")
      sb.Append(KeyTable.ForeignKeyTable.Name & " () as XPCollection(Of " & GetClassName(KeyTable.ForeignKeyTable) & ")")
      sb.Append(vbCrLf)
      sb.Append(vbTab & "Get" & vbCrLf)
      sb.Append(vbTab & "Return GetCollection(Of " & GetClassName(KeyTable.ForeignKeyTable) & ")(")
      sb.Append("""" & KeyTable.ForeignKeyTable.Name & """" & ")" & vbCrLf)
      sb.Append(vbTab & "End Get" & vbCrLf)
      sb.Append("End Property" & vbCrLf)
      Return sb.ToString
   End Function
   <CLSCompliant(False)> _
   Public Function GetVbTableKeyDescription(ByVal Table As TableSchema) As String
      Dim sb As New StringBuilder
      Dim k As TableKeySchema
      Dim c As ColumnSchema
      sb.Append(String.Format("' Key overview for table {0} in database {1}", Table.Name, Table.Database.Name) & vbCrLf)
      sb.Append("' ========================================================" & vbCrLf & vbCrLf)
      sb.Append("' Primary Key" & vbCrLf)
      sb.Append("' ------------" & vbCrLf)

      For Each c In Table.PrimaryKey.MemberColumns
         sb.Append(String.Format("' {0}Column: {1}", vbTab, c.Name) & vbCrLf)
      Next

      sb.Append(vbCrLf)
      sb.Append("' Keys  " & vbCrLf)
      sb.Append("' ------" & vbCrLf)
      For Each k In Table.Keys
         sb.Append(String.Format("' Key: {0} PrimaryKeytable: {1}", k.Name, k.PrimaryKeyTable.Name & vbCrLf))
         sb.Append(String.Format("' {0} ForeignKeytable: {1}", vbTab, k.ForeignKeyTable.Name) & vbCrLf)

         For Each c In k.ForeignKeyMemberColumns
            sb.Append(String.Format("' {0}Column: {1}", vbTab, c.Name) & vbCrLf)
         Next
      Next
      sb.Append(vbCrLf)
      sb.Append("' Foreign Keys  " & vbCrLf)
      sb.Append("' --------------" & vbCrLf)
      For Each k In Table.ForeignKeys
         sb.Append(String.Format("' Key: {0} PrimaryKeytable: {1}", k.Name, k.PrimaryKeyTable.Name & vbCrLf))
         sb.Append(String.Format("' {0} ForeignKeytable: {1}", vbTab, k.ForeignKeyTable.Name) & vbCrLf)

         For Each c In k.ForeignKeyMemberColumns
            sb.Append(String.Format("' {0}Column: {1}", vbTab, c.Name) & vbCrLf)
         Next
      Next

      Return sb.ToString
   End Function
   Public Function Level(ByVal n As Integer, _
                         Optional ByVal NewLine As Boolean = False) As String
      'Provides formatting for the outputted code
      'The INDENT_LEVEL_SPACES defines how many spaces 
      '  are in a level and is declared at the top of the class
      Dim sLevel As String

      If Not NewLine Then
         sLevel = Space((n * INDENT_LEVEL_SPACES))

      Else
         sLevel = vbNewLine + Space((n * INDENT_LEVEL_SPACES))
      End If

      Return sLevel
   End Function
	   <CLSCompliant(False)> _
   Public Function GetDescription(ByVal Column As ColumnSchema) As String
      Dim sDescription As String
      Try
         sDescription = Column.Description
      Catch
         Return ""
      End Try
      If sDescription = String.Empty Then Return ""
      Return sDescription
   End Function
   <CLSCompliant(False)> _
   Public Function GetDescriptionProperty(ByVal Key As String, ByVal Column As ColumnSchema) As String
      Dim sDescription As String
	   Dim oDict as new StringDictionary
		
      sDescription = GetDescription(Column)
      If sDescription = String.Empty Then Return ""
      odict.LoadParameterString(sDescription)
      Return odict.item(Key,"")
   End Function
   <CLSCompliant(False)> _
   Public Function GetVBColumnDefault(ByVal Column As ColumnSchema) As String
      Dim sDefault As String
      Dim sType As String
      Dim s As String
      Try
         sDefault = CType(Column.ExtendedProperties("CS_DEFAULT").Value, String)
      Catch
         Return ""
      End Try
      If sDefault = String.Empty Then Return ""
      sType = GetVBVariableType(Column)
      Select Case sType
         Case "String"
            s = sDefault
            If s.StartsWith("(") AndAlso s.EndsWith(")") Then s = s.Substring(1, s.Length - 2)
            If s.StartsWith("'") AndAlso s.EndsWith("'") Then s = """" & s.Substring(1, s.Length - 2) & """"
         Case "Boolean"
            s = sDefault
            If s.StartsWith("(") AndAlso s.EndsWith(")") Then s = s.Substring(1, s.Length - 2)
            If s = "0" Then
               s = "False"
            Else
               s = "True"
            End If
         Case "Decimal"
            s = sDefault
            If s.StartsWith("(") AndAlso s.EndsWith(")") Then s = s.Substring(1, s.Length - 2)
         Case "Date"
            s = sDefault
            If s.StartsWith("(") AndAlso s.EndsWith(")") Then s = s.Substring(1, s.Length - 2)
            If s.StartsWith("'") AndAlso s.EndsWith("'") Then s = "#" & s.Substring(1, s.Length - 2) & "#"
         Case "Double", "Short", "Integer", "Long", "Float"
            s = sDefault
            If s.StartsWith("(") AndAlso s.EndsWith(")") Then s = s.Substring(1, s.Length - 2)

         Case Else
            Return "__UnknownDataTypeForDefault__" + Column.NativeType
      End Select
      Return s
   End Function
   <CLSCompliant(False)> _
   Public Function GetVbForeignKeyObjectByKey(ByVal Infix As String, ByVal KeyTable As TableKeySchema) As String
      Dim sb As New StringBuilder
      Dim s As String
      'omDatenbank = CType(omSession.GetObjectByKey(GetType(SD.Datenbank), i), SD.Datenbank)
      'omProjekt=CType(me.session.getobjectbykey(Gettype(Projekt),1),Projekt
      ' Loads the Object from column-default
      s = GetVBColumnDefault(KeyTable.ForeignKeyMemberColumns(0))
      If s = "" Then sb.Append("'")
      sb.Append(vbTab & "o" & Infix)
      sb.Append(GetClassName(KeyTable.PrimaryKey.Table))
      sb.Append("=")
      sb.Append("CType(me.session.getobjectbykey(")
      sb.Append("Gettype(")
      sb.Append(GetClassName(KeyTable.PrimaryKey.Table))
      sb.Append("),")
      sb.Append(s)
      sb.Append("),")
      sb.Append(GetClassName(KeyTable.PrimaryKey.Table))
      sb.Append(")")
      sb.Append(vbCrLf)
      Return sb.ToString
   End Function
	Public Function GetVBFindBy(ByVal Index as IndexSchema, ByVal Table As TableSchema) as String
		Dim sb as new Stringbuilder
		sb.append("Shared Function " & GetClassName(Table) &"By")
		For each Column as ColumnSchema in index.MemberColumns
			sb.append("_" & Column.Name)
		next
		sb.append("( _" & vbcrlf)
		For each Column as ColumnSchema in index.MemberColumns
			sb.append(vbtab & "ByVal " & Column.Name & " as " & GetVBVariableType(column) & ", _" & vbcrlf)
		next
		sb.append(vbtab & "Optional ByVal TheSession As Session = Nothing _" & vbcrlf)
		sb.append(") as " & GetClassName(Table) & vbcrlf)
		sb.append("	Dim oCriteria As DevExpress.Data.Filtering.CriteriaOperator" & vbcrlf)
		sb.append("	oCriteria = DevExpress.Data.Filtering.CriteriaOperator.Parse(""")
		Dim b as boolean = true
		For each Column as ColumnSchema in index.MemberColumns
			if Not b then
				sb.append(" and ")
			end If
			b=False
			sb.append(vbtab & "[" & Column.Name & "] = ? " )
		next
		sb.Append("""" )
		For each Column as ColumnSchema in index.MemberColumns
			sb.append("," & Column.Name  )
		next
		sb.Append(")" & vbcrlf  )
		sb.append("	If TheSession Is Nothing Then TheSession = new DevExpress.Xpo.Session" & vbcrlf)
		sb.append("	Return CType(TheSession.FindObject(GetType(" & GetClassName(Table) & "), oCriteria), " & GetClassName(Table) & ")" & vbcrlf )
      sb.append("End Function" & vbcrlf)
		return sb.tostring
	end function
	Public Function GetVBMultiFieldIndex( Column as Columnschema) as String
		Dim s as string
		s=""
		for each  Index as IndexSchema in Column.Table.Indexes 
			If Index.IsPrimaryKey then Continue For
			If index.memberColumns(0).Name <> Column.name  then Continue for
			s= s & "Indexed("
			If index.memberColumns.Count > 1 then
				s = s & """"
				For i as Integer = 1 to index.memberColumns.Count -1
					If i > 2 then s = s & ";"
					s= s & index.memberColumns(I).Name
				Next
				s = s & ""","
			end If
			s = s & "Unique:="
			if Index.IsUnique then
				s= s & "True"
			else
				s= s & "False"
			end If
			s= s & "), _"
			exit For	
		next
		Return s
	End Function
	Public Function GetVBAttributes(Column as ColumnSchema, IncludeDescriptionAttribute as Boolean,IncludeTooltipAttribute as Boolean) as string
			Dim sRet as String =""
			Dim s as String
			s=GetDescriptionProperty("DN", column)
			if s="" then s=column.name
			sRet= sRet & vbtab & "DisplayName(""" & s & """)"
			If IncludeDescriptionAttribute then
				s=GetDescriptionProperty("DC", column)
				If s="" then s=Column.Name
				sRet = sRet & ", _"& vbcrlf
				sRet = sRet & vbtab & "SX.Attributes.Description(""" & s & """)"
			end If
			If IncludeTooltipAttribute then
				s=GetDescriptionProperty("TT", column)
				If s="" then s=Column.Name
				sret= sret & ", _" & vbcrlf
				sRet = sRet & vbtab & "SX.Attributes.ToolTip(""" & s & """)"
			end If
			s=GetVBXPOStringSizeAttribute(Column)
			if s <> "" then
				sRet = sREt & ", _"  & vbcrlf
				sRet = sRet &  vbtab & s
			end If	
			return sRet
	End Function
End Class
<Serializable()> Public Class StringDictionary

   Inherits DictionaryBase
   ''' <summary>
   ''' Stringdictionary, Key is caseinsensitive,Item delivers defaultvalue if not found
   ''' </summary>
   ''' <remarks></remarks>
   Public Sub New()
      MyBase.new()
   End Sub
   ''' <summary>
   ''' Adds the specified key.
   ''' </summary>
   ''' <param name="Key">The key.</param>
   ''' <param name="Value">The value.</param>
   Public Sub Add(ByVal Key As String, ByVal Value As String)
      Key = Key.ToLower
      If MyBase.Dictionary.Contains(Key) Then MyBase.Dictionary.Remove(Key)
      If Value = "" Then Value = "###EmptyString###"
      MyBase.Dictionary.Add(Key, Value)
   End Sub
   ''' <summary>
   ''' Items the specified key.
   ''' </summary>
   ''' <param name="Key">The key.</param>
   ''' <param name="DefaultValue">The default value.</param>
   ''' <returns></returns>
   Public Shadows Function Item(ByVal Key As String, ByVal DefaultValue As String) As String
      Dim s As String
      Key = Key.ToLower
      If MyBase.Dictionary.Contains(Key) Then
         s = CType(MyBase.Dictionary.Item(Key), String)
         If s = "###EmptyString###" Then s = ""
         Return s
      Else
         Me.Add(Key, DefaultValue)
         Return DefaultValue
      End If
   End Function
   ''' <summary>
   ''' Gets the Item with the specified key or nothing if not found.
   ''' </summary>
   ''' <param name="Key">The key.</param>
   ''' <returns></returns>
   Public Shadows Function Item(ByVal Key As String) As String
      Dim s As String
      s = CType(MyBase.Dictionary.Item(Key.ToLower), String)
      If s Is Nothing Then Return Nothing
      If s = "###EmptyString###" Then s = ""
      Return s
   End Function
   ''' <summary>
   ''' 
   ''' </summary>
   ''' <value></value>
   ''' <doc>
   ''' <summary>Gets an <see cref="T:System.Collections.ICollection"></see> object containing the keys of the <see cref="T:System.Collections.IDictionary"></see> object.</summary>
   ''' <returns>An <see cref="T:System.Collections.ICollection"></see> object containing the keys of the <see cref="T:System.Collections.IDictionary"></see> object.</returns>
   ''' <filterpriority>2</filterpriority>
   ''' </doc>
   Public ReadOnly Property Keys() As ICollection
      Get
         Return MyBase.Dictionary.Keys
      End Get
   End Property

   ''' <summary>
   ''' 
   ''' </summary>
   ''' <value></value>
   ''' <doc>
   ''' <summary>Gets an <see cref="T:System.Collections.ICollection"></see> object containing the values in the <see cref="T:System.Collections.IDictionary"></see> object.</summary>
   ''' <returns>An <see cref="T:System.Collections.ICollection"></see> object containing the values in the <see cref="T:System.Collections.IDictionary"></see> object.</returns>
   ''' <filterpriority>2</filterpriority>
   ''' </doc>
   Public ReadOnly Property Values() As ICollection
      Get
         Return MyBase.Dictionary.Values
      End Get
   End Property
   ''' <summary>
   ''' Determines whether the specified key contains key.
   ''' </summary>
   ''' <param name="key">The key.</param>
   ''' <returns>
   ''' <c>true</c> if the specified key contains key; otherwise, <c>false</c>.
   ''' </returns>
   Public Function ContainsKey(ByVal key As String) As Boolean
      Return MyBase.Dictionary.Contains(key.ToLower)
   End Function 'Contains

   ''' <summary>
   ''' Removes the specified key.
   ''' </summary>
   ''' <param name="key">The key.</param>
   Public Sub Remove(ByVal key As String)
      MyBase.Dictionary.Remove(key.ToLower)
   End Sub 'Remove
   Public Sub LoadParameterString(ByVal Item As String)
      Dim l As Integer
      Dim l1 As Integer
      Dim l2 As Integer
      Dim l3 As Integer
      Dim s As String
      Dim sApo As String
      Dim sBuffer As String
      Dim sKey As String
      Dim sValue As String

      sBuffer = Trim$(Item)

      Do While sBuffer <> ""
         Do
            ' Suche das = für Key
            l = InStr(sBuffer, "=")

            If l = 0 Then
               sBuffer = ""
               Exit Do
            End If

            l1 = InStr(sBuffer, ",")
            l2 = InStr(sBuffer, vbCr)
            l3 = InStr(sBuffer, vbLf)

            If l1 > 0 And l1 < l Then
               sBuffer = Mid$(sBuffer, l1 + 1)
               Exit Do
            End If

            If l2 > 0 And l2 < l Then
               sBuffer = Mid$(sBuffer, l2 + 1)
               Exit Do
            End If

            If l3 > 0 And l3 < l Then
               sBuffer = Mid$(sBuffer, l3 + 1)
               Exit Do
            End If

            'In sKey steht der Key
            sKey = Trim$(Left$(sBuffer, l - 1))
            sKey = Replace(sKey, vbCr, "")
            sKey = Replace(sKey, vbLf, "")

            'Value finden
            sBuffer = LTrim$(Mid$(sBuffer, l + 1))
            sApo = Left$(sBuffer, 1)

            If sApo <> """" And sApo <> "'" Then
               'Value ist nicht durch "" oder '' begrenzt, suche daher
               'ein Komma oder CR/LF/CRLF. CR oder LF oder CRLF im Value ist
               'nicht möglich, wenn der String nicht durch "" oder ''
               'begrenzt wird!

               l1 = InStr(sBuffer, ",")
               l2 = InStr(sBuffer, vbCr)
               l3 = InStr(sBuffer, vbLf)

               If l1 + l2 + l3 = 0 Then 'nicht da, daher alles nehmen
                  sValue = Trim$(sBuffer)
                  sBuffer = "" 'und auch schon Ende
               Else
                  l = Integer.MaxValue
                  If l1 > 0 And l1 < l Then
                     l = l1
                  End If
                  If l2 > 0 And l2 < l Then
                     l = l2
                  End If
                  If l3 > 0 And l3 < l Then
                     l = l3
                  End If

                  sValue = Trim$(Left$(sBuffer, l - 1))
                  sBuffer = LTrim$(Mid$(sBuffer, l))
               End If
            Else
               'Value ist durch "" oder '' begrenzt, suche daher
               'das paarige Hochkomma. CR oder LF oder CRLF im Value ist
               'möglich, wenn der String nicht durch "" oder ''
               'begrenzt wird! Diese Zeichen werden jedoch im Resultat
               'ausgefiltert!

               l = 1

               Do While True
                  l = InStr(l + 1, sBuffer, sApo)

                  If l = 0 Then
                     MsgBox( _
                        "Der folgende Parameterstring ist ungültig:" & vbCrLf & _
                        "<" & Item & ">", _
                        vbCritical)
                     'Err.Raise SyCSyCollection_LoadParameterStringProblem, ModulName & "." & FunctionName, SyCSyCollection_LoadParameterStringProblemT
                     Exit Sub
                  End If

                  If l = Len(sBuffer) Then Exit Do 'wir sind bereits am Ende

                  If Mid$(sBuffer, l + 1, 1) <> sApo Then
                     Exit Do
                  End If

                  l = l + 1
               Loop

               sValue = Mid$(sBuffer, 2, l - 2)
               sBuffer = LTrim$(Mid$(sBuffer, l))
            End If

            s = Left$(sBuffer, 1)

            Do While sBuffer <> "" And s <> "," And s <> vbCr And s <> vbLf
               sBuffer = LTrim$(Mid$(sBuffer, 2))
               s = Left$(sBuffer, 1)
            Loop

            s = Left$(sBuffer, 1)

            Do While sBuffer <> "" And (s = " " Or s = "," Or s = vbCr Or s = vbLf)
               sBuffer = LTrim$(Mid$(sBuffer, 2))
               s = Left$(sBuffer, 1)
            Loop

            sValue = Replace(sValue, sApo & sApo, sApo)
            sValue = Replace(sValue, vbCr, "")
            sValue = Replace(sValue, vbLf, "")

            Me.Add(sKey, sValue)
            Exit Do
         Loop
      Loop
   End Sub
End Class

